local clr = LUMINARY.color
local didGuildLoadArray = {}
local getguildname = {}
local finalmath = 0
local SI = LUMINARY.SI
local searchTable = {}
local alertHistory = {}




function removeDuplicates(tbl)
    local timestamps = {}
    local newTable = {}
    for index, record in ipairs(tbl) do
        if timestamps[record.timestampz] == nil and timestamps[record.itemName] == nil
                and timestamps[record.seller] == nil and timestamps[record.buyer] == nil
                and timestamps[record.quantity] == nil and timestamps[record.cleanName] == nil and
                timestamps[record.quantity] == nil and timestamps[record.quantity] == nil then

            timestamps[record.timestampz] = 1

            table.insert(newTable, record)
        end
    end

    return newTable
end

local function fixMyTables()
    if #mLuminarySavedTHVarsNew.ALL_GUILD_SALES > mLuminarySavedTHVarsNew.HowMuchHistory then
        table.sort(mLuminarySavedTHVarsNew.ALL_GUILD_SALES, function(a, b) return a.timestampz > b.timestampz end)
        for k, v in pairs(mLuminarySavedTHVarsNew.ALL_GUILD_SALES) do
            if k > mLuminarySavedTHVarsNew.HowMuchHistory then
                table.remove(mLuminarySavedTHVarsNew.ALL_GUILD_SALES[k])
                mLuminarySavedTHVarsNew.ALL_GUILD_SALES[k] = nil
            end
        end
    end
end



local function thisReallySucks()


    mLuminarySavedTHVarsNew.ALL_PLAYER_SALES = removeDuplicates(mLuminarySavedTHVarsNew.ALL_PLAYER_SALES)
    mLuminarySavedTHVarsNew.ALL_GUILD_SALES = removeDuplicates(mLuminarySavedTHVarsNew.ALL_GUILD_SALES)

    -- Give the tables 1 full second to process.
    zo_callLater(function() fixMyTables() end, 2000)
end


function LUMINARY.SearchGuildHistory(stringz, sort)
    if stringz == nil or string == " " then setupRecentSales(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_PRICE_DESC, mLuminarySavedTHVarsNew.ALL_GUILD_SALES) end
    searchTable = {}
    local e = zo_strformat(SI_TOOLTIP_ITEM_NAME, string.gsub(stringz, "|H(.-):(.-)|h", ""))
    local b = string.gsub(e, "(^.*)", "")
    local g = string.gsub(b, "(|H)", "")

    local searchForItem = string.lower(g)
    for k, v in ipairs(mLuminarySavedTHVarsNew.ALL_GUILD_SALES) do
        --        if string.lower(g) == string.lower(v.cleanName) then
        if string.lower(v.cleanName):find(searchForItem) then
            if v.cleanName ~= nil then
                table.insert(searchTable, v)
            end
        end
    end
    if sort == nil then
        sort = LUMINARY.LIST_BY_PRICE_DESC
    end
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. SI.get(SI.TOTALRECORDEDHISTORY) .. "  (Total items found: " .. #searchTable .. ")")
    setupRecentSales(LUMINARY.LIST_BY_SEARCH, sort, searchTable)
end

function setupRecentSales(type, sort, table)

    if type == LUMINARY.LIST_BY_SELF then
        LUMINARY.LIST_CONTROLLER = LUMINARY.LIST_BY_SELF
        LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. "Your Sales")
        LumAllSales:add_message(mLuminarySavedTHVarsNew.ALL_PLAYER_SALES, sort)
        --   LUMINARY:logV("Sort by self")

    elseif type == LUMINARY.LIST_BY_ALL then
        LUMINARY.LIST_CONTROLLER = LUMINARY.LIST_BY_ALL
        LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. SI.get(SI.TOTALRECORDEDHISTORY) .. "  (Total items found: " .. #mLuminarySavedTHVarsNew.ALL_GUILD_SALES .. ")")

        LumAllSales:add_message(mLuminarySavedTHVarsNew.ALL_GUILD_SALES, sort)
        --   LUMINARY.logV("Sort by ALL")
    elseif type == LUMINARY.LIST_BY_SEARCH then
        LUMINARY.LIST_CONTROLLER = LUMINARY.LIST_BY_SEARCH
        LumAllSales:add_message(table, sort)
        --   LUMINARY.logV("Sort by SEARCH")
    else
        LUMINARY.LIST_CONTROLLER = LUMINARY.ALL_PLAYER_SALES
        LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. "Your Sales")
        LumAllSales:add_message(mLuminarySavedTHVarsNew.ALL_PLAYER_SALES, LUMINARY.LIST_BY_PRICE_ASC)
        --      LUMINARY.logV("Sort by else")
    end
end

function LUMINARY:ToggleLumTradeHistory()

    if LUMINARY.win.Main_Control:IsHidden() then
        LUMINARY.win.Main_Control:SetHidden(false)
    else
        LUMINARY.win.Main_Control:SetHidden(true)
    end
end




function mCompare(val, table)
    for k, v in ipairs(table) do
        if val.timestampz <= v.timestampz + 3 and val.timestampz >= v.timestampz - 3 and
                val.cleanName == v.cleanName then
            return false
        end
    end

    return true
end



local function findMySum(name, tbl)

    local sum = 0
    local counts = 1

    for k, v in ipairs(tbl) do
        if name == v.cleanName then
            sum = sum + tonumber(v.soldAmount)
            counts = counts + tonumber(v.quantity)
        end
    end

    local sumtoReturn = sum / counts
    d(sumtoReturn)
    return sumtoReturn
end

local function allSalesCallback(j, bool)
    if totalGuilds == 0 then return
    end ---------------- return use if they are in no guilds

     alertHistory = {}
    local username = GetDisplayName()
    local totalGuilds = GetNumGuilds()
    local alertuser = false

    local mBool = bool
    local mLogz = logz

    local numEvents = GetNumGuildEvents(GetGuildId(j), GUILD_HISTORY_SALES)
    for i = 0, numEvents do
        -- local array to temp save data
        local e = {}
        e.eventType, e.secsSinceEvent, e.seller,
        e.buyer, e.quantity, e.itemName,
        e.soldAmount = GetGuildEventInfo(GetGuildId(j), GUILD_HISTORY_SALES, i)
        e.guildName = GetGuildName(GetGuildId(j))
        local theTimeStampTime = GetTimeStamp()
        e.timestampz = theTimeStampTime - e.secsSinceEvent



        if e.itemName ~= nil then
            local setup = zo_strformat(SI_TOOLTIP_ITEM_NAME, string.gsub(e.itemName, "|H(.-):(.-)|h", ""))
            local b = string.gsub(setup, "(^.*)", "")
            local d = string.gsub(b, "(|H)", "")
            e.cleanName = d

            if e.seller ~= nil and e.buyer ~= nil and e.soldAmount ~= nil and e.timestampz ~= nil then
                if mLuminarySavedTHVarsNew.ALL_GUILD_SALES ~= nil then
                    if mCompare(e, mLuminarySavedTHVarsNew.ALL_GUILD_SALES) then
                        table.insert(mLuminarySavedTHVarsNew.ALL_GUILD_SALES, e)
                    end
                else
                    table.insert(mLuminarySavedTHVarsNew.ALL_GUILD_SALES, e)
                end
            end
            if e.seller == username and e.seller ~= nil and e.buyer ~= nil and e.soldAmount ~= nil and e.timestampz ~= nil then
                if mLuminarySavedTHVarsNew.ALL_PLAYER_SALES ~= nil then
                    if mCompare(e, mLuminarySavedTHVarsNew.ALL_PLAYER_SALES) then
                        table.insert(mLuminarySavedTHVarsNew.ALL_PLAYER_SALES, e)
                        if e.secsSinceEvent < 180 then
                            table.insert(alertHistory, e)
                        end
                    end
                else
                    table.insert(mLuminarySavedTHVarsNew.ALL_PLAYER_SALES, e)
                end


                if e.secsSinceEvent < mLuminarySavedTHVarsNew.Frequency then
                    alertuser = true
                end
            end
        end
    end

    if mLuminarySavedTHVarsNew.ShowSoldAlert then
        if mBool then
            if alertuser then
          --      if onlyAlertOnce then   -- TODO this is not a fix
                    --- Sort the table so we alert the most recent items
                    table.sort(alertHistory, function(a, b) return a.secsSinceEvent < b.secsSinceEvent
                    end)

                    for i, event in ipairs(alertHistory) do
                       table.sort(event, function(a, b) return a.secsSinceEvent < b.secsSinceEvent
                        end)

                        if event.secsSinceEvent < 180 then
                            if mLuminarySavedTHVarsNew.Pick_Gold then
                                local somemath = event.soldAmount * 0.1
                                local moreMath = event.soldAmount - somemath
                                if moreMath % 2 ~= 0.5 then
                                    finalmath = math.floor(moreMath + 0.5)
                                else finalmath = moreMath - 0.5
                                end
                            else
                                finalmath = event.soldAmount
                            end

                            local secToMin = tonumber(string.format("%.4f", math.floor(event.secsSinceEvent / 60)))

                            if event.secsSinceEvent <= 59 then
                                ZO_CenterScreenAnnounce_GetAnnounceObject():AddMessage(EVENT_SKILL_RANK_UPDATE, CSA_EVENT_LARGE_TEXT, SOUNDS.BOOK_ACQUIRED,
                                    clr.colLegendary .. "Item Sold: " .. clr.colGreen .. event.cleanName .. " For: " .. clr.colLegendary .. finalmath .. "G " .. clr.colWhite .. event.secsSinceEvent .. " secs ago")

                            else
                                ZO_CenterScreenAnnounce_GetAnnounceObject():AddMessage(EVENT_SKILL_RANK_UPDATE, CSA_EVENT_LARGE_TEXT, SOUNDS.BOOK_ACQUIRED,
                                    clr.colLegendary .. "Item Sold: " .. clr.colGreen .. event.cleanName .. " For: " .. clr.colLegendary .. finalmath .. "G " .. clr.colWhite .. secToMin .. " min(s) ago")
                            end
                        end
                    end
                end
       --     end
        end
    end
end

local function letsSpaceOutTheChecks(bool, logz)
    local bool = bool
    if LUMINARY.isLoaded then
        if totalGuilds == 0 then return
        end ---------------- return use if they are in no guilds

        local username = GetDisplayName()
        local totalGuilds = GetNumGuilds()
        local alertuser = false



        --where j is the guild id index
        for j = 1, totalGuilds do
            if j == 1 then
                if (RequestGuildHistoryCategoryNewest(GetGuildId(j), GUILD_HISTORY_SALES)) then

                    zo_callLater(function() allSalesCallback(j, bool) end, 500)
                end
            elseif j == 2 then
                if RequestGuildHistoryCategoryNewest(GetGuildId(j), GUILD_HISTORY_SALES) then
                    zo_callLater(function() allSalesCallback(j, bool) end, 2500)
                end
            elseif j == 3 then
                if RequestGuildHistoryCategoryNewest(GetGuildId(j), GUILD_HISTORY_SALES) then
                    zo_callLater(function() allSalesCallback(j, bool) end, 4000)
                end
            elseif j == 4 then
                if RequestGuildHistoryCategoryNewest(GetGuildId(j), GUILD_HISTORY_SALES) then
                    zo_callLater(function() allSalesCallback(j, bool) end, 6000)
                end
            elseif j == 5 then
                if RequestGuildHistoryCategoryNewest(GetGuildId(j), GUILD_HISTORY_SALES) then
                    zo_callLater(function() allSalesCallback(j, bool) end, 8000)
                end
            end
        end
        zo_callLater(function() thisReallySucks() end, 11500)
    end
end


function LUMINARY.getAllSales(bool, logz) -- This will list all sales that we've been able to record.
    if LUMINARY.isLoaded then
        --TODO refactor this, spaceoutthechecks actually can space out the checks now :)
        zo_callLater(function() letsSpaceOutTheChecks(bool, logz) end, 1000)
    end
end




function LUMINARY:HideOnClick()
    -- LUMINARY.TH:SetHidden(true)
    LUMINARY.win.Main_Control:SetHidden(true)
end


function LUMINARY:PurgeGuildHistory()
    --  LUMINARY.ALL_GUILD_SALES = {}
end

function LUMINARY:ForceLoadGuildHistory()
    if GetNumGuilds() == 0 then return
    end

    if not LUMINARY.isLoaded then

        zo_callLater(function() thisReallySucks() end, 1000)


        --Check if they've left a guild or just get guilds in general
        totalGuilds = GetNumGuilds()
        if totalGuilds == nil then return
        end
        if totalGuilds ~= nil then
            if totalGuilds ~= 0 then
                for i = 0, totalGuilds do
                    --Need to request for GuildHistory otherwise it will never load.
                    --This will return true or false
                    didGuildLoadArray[i] = RequestGuildHistoryCategoryNewest(GetGuildId(i), GUILD_HISTORY_SALES)
                    getguildname[i] = GetGuildName(GetGuildId(i))


                    -- Just Because -- lets piss ESO off and load old items. Fix your damn servers.
                    RequestGuildHistoryCategoryOlder(GetGuildId(i), GUILD_HISTORY_SALES)
                end

                for j = 0, totalGuilds do
                    amILoaded = didGuildLoadArray[j]

                    -- if at least 1 guild is loaded we're set for some history. If not we'll keep trying every few seconds.
                    if amILoaded then
                        LUMINARY.isLoaded = true
                    end
                end
                if amILoaded then
                    EVENT_MANAGER:UnregisterForEvent(LUMINARY.appName, EVENT_PLAYER_ACTIVATED)
                    --   d(clr.colArtifact .. "Luminary " .. clr.colWhite .. "Trade History " .. SI.get(SI.LOADED))
                    LUMINARY.getAllSales(true)
                end
            end
        end
    end
end

function LUMINARY:MailBoxIsOpen()
    if mLuminarySavedTHVarsNew.Enable_Mail then

        LUMINARY.getAllSales(false)
        setupRecentSales(LUMINARY.LIST_BY_SELF, LUMINARY.LIST_BY_TIME_ASC)
        LUMINARY.win.Main_Control:SetHidden(false)
    end
end

function LUMINARY:MailBoxIsClosed()
    LUMINARY.win.Main_Control:SetHidden(true)
end


function LUMINARY:notifyUpdateMail()
    LUMINARY.getAllSales(true)
end


function LUMINARY:mTradeStoreOpen()

    if mLuminarySavedTHVarsNew.Enable_Trade then
        LUMINARY.getAllSales(false)
        setupRecentSales(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_TIME_ASC)
        --  LUMINARY.TH:SetHidden(false)
        LUMINARY.win.Main_Control:SetHidden(false)
    end
end

function LUMINARY:mTradeStoreClosed()
    LUMINARY.win.Main_Control:SetHidden(true)
end




function LuminaryTradeHistorySalesUpdate()

    ----- if luminary did not load on player initalized, we'll try every 15 seconds.
    if not LUMINARY.isLoaded then
        if BufferReached("TradeLoadAttempts", 15) then
            LUMINARY.ForceLoadGuildHistory()
        end
    end


    if BufferReached("RefreshGuildHistory", mLuminarySavedTHVarsNew.Frequency) then
        onlyAlertOnce = true
        LUMINARY.getAllSales(true)
    end
end

function sellPromptTest()
    d("test")
    local boolz = true
    local log = false
    LUMINARY.getAllSales(boolz, log)
end

local function mHelpOptions()
    d("Welcome to Luminary's Trade History")
    d("Slash Commands are: ")
    d("/qaz for quick show of trade history")
    d("/history show for quick show of trade history (same as above)")
end

local function mCommandToShowHistory()
    LUMINARY.getAllSales(false)
    setupRecentSales(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_TIME_ASC)
    LUMINARY.win.Main_Control:SetHidden(false)
end

EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_ADD_ON_LOADED, OnAddOnLoaded)


SLASH_COMMANDS["/history"] = mHelpOptions
SLASH_COMMANDS["/tester"] = testingStuff
SLASH_COMMANDS["/qaz"] = mCommandToShowHistory
SLASH_COMMANDS["/showhistory"] = mCommandToShowHistory
SLASH_COMMANDS["/lthsales"] = LUMINARY.mTradeStoreOpen
SLASH_COMMANDS["/lthmail"] = MailBoxIsOpen
SLASH_COMMANDS["/lth testerx"] = mTestMethod
SLASH_COMMANDS["/lth testerz"] = mTestMethodz
SLASH_COMMANDS["/lth testx"] = testThis
SLASH_COMMANDS["/alertz"] = sellPromptTest
