local wm = WINDOW_MANAGER

local TITLE_HEIGHT = 45
local LINES_OFFSET = TITLE_HEIGHT
local SLIDER_WIDTH = 35
local should_hide = false
local LumSelf = {}
local SI = LUMINARY.SI
local priceSorter = true
local timerSorter = true
local lthline = {}
local totalLines = 0


-- Utility

local function clamp(val, min_, max_)
    val = math.max(val, min_)
    return math.min(val, max_)
end




-- Private API
local function TouchMyTool(name)
    lthtooltip = PopupTooltip
    lthtooltip:ClearLines()
    lthtooltip:SetLink(name)
    lthtooltip:SetHidden(false)
   -- d(GetItemLinkInfo(name))
    local CompMyToolz = GetComparisonEquipSlotsFromItemLink(name)
    local Link2 = CompMyToolz and GetItemLink(BAG_WORN, CompMyToolz, LINK_STYLE_DEFAULT)
    lthtooltipCompare = ComparativeTooltip1

    lthtooltipCompare:ClearLines()
    if Link2 == "" or nil then return end
    if CompMyToolz == nil then return end
    lthtooltipCompare:SetAnchor(BOTTOMLEFT, lthtooltip, TOPLEFT, 0, -40)
    lthtooltipCompare:SetBagItem(BAG_WORN, CompMyToolz)
    lthtooltipCompare:SetHidden(false)
end



local function HideTouchMyTool(name)
    lthtooltip:SetHidden(true)
    lthtooltipCompare:SetHidden(true)
end



local function LinkInChat(name)
    ZO_ChatWindowTextEntryEditBox:SetText(ZO_ChatWindowTextEntryEditBox:GetText() .. name)
end

local function WhisperTarget(name)
    if SCENE_MANAGER.currentScene.name == "mailSend" then
        ZO_MailSendToField:SetText("")
        ZO_MailSendToField:SetText(ZO_MailSendToField:GetText().. name )
    else
        ZO_ChatWindowTextEntryEditBox:SetText("")
        ZO_ChatWindowTextEntryEditBox:SetText(ZO_ChatWindowTextEntryEditBox:GetText() .. "/w " .. name .. " ")
    end
end

local function _set_line_counts(LumSelf)
    LumSelf.num_visible_lines = math.floor((LumSelf.control:GetHeight() - LINES_OFFSET) / LumSelf.line_height)
    LumSelf.num_visible_lines = math.min(LumSelf.num_visible_lines, #LumSelf.sellLines)

    LumSelf.num_hidden_lines = math.max(0, #LumSelf.sellLines - LumSelf.num_visible_lines)
    if LumSelf.num_hidden_lines == 0 then
        LumSelf.offset = 0
    end
end

function getSelfGuildSales()
    LUMINARY.LIST_CONTROLLER = LUMINARY.LIST_BY_SELF
    setupRecentSales(LUMINARY.LIST_BY_SELF, LUMINARY.LIST_BY_TIME_ASC)
end

function getAllGuildMemberListings()
    LUMINARY.LIST_CONTROLLER = LUMINARY.LIST_BY_ALL
    setupRecentSales(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_TIME_ASC)
end

local function sortByPrice()
    if not timerSorter then
        LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortdown.dds")
        if LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_ALL then
            LUMINARY.sorter(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_PRICE_DESC)


        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SELF then
            LUMINARY.sorter(LUMINARY.LIST_BY_SELF, LUMINARY.LIST_BY_PRICE_DESC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SEARCH then
            LUMINARY.sorter(LUMINARY.LIST_BY_SEARCH, LUMINARY.LIST_BY_PRICE_DESC)
        end
        timerSorter = true
    else
        LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortup.dds")
        if LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_ALL then
            LUMINARY.sorter(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_PRICE_ASC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SELF then
            LUMINARY.sorter(LUMINARY.LIST_BY_SELF, LUMINARY.LIST_BY_PRICE_ASC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SEARCH then
            LUMINARY.sorter(LUMINARY.LIST_BY_SEARCH, LUMINARY.LIST_BY_PRICE_ASC)
        end
        timerSorter = false
    end
end


local function sortByTime()
    if not priceSorter then
        LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortup.dds")
        if LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_ALL then
            LUMINARY.sorter(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_TIME_DESC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SELF then
            LUMINARY.sorter(LUMINARY.LIST_BY_SELF, LUMINARY.LIST_BY_TIME_DESC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SEARCH then
            LUMINARY.sorter(LUMINARY.LIST_BY_SEARCH, LUMINARY.LIST_BY_TIME_DESC)
        end
        priceSorter = true
    else
        LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")

        LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortdown.dds")
        if LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_ALL then
            LUMINARY.sorter(LUMINARY.LIST_BY_ALL, LUMINARY.LIST_BY_TIME_ASC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SELF then
            LUMINARY.sorter(LUMINARY.LIST_BY_SELF, LUMINARY.LIST_BY_TIME_ASC)

        elseif LUMINARY.LIST_CONTROLLER == LUMINARY.LIST_BY_SEARCH then
            LUMINARY.sorter(LUMINARY.LIST_BY_SEARCH, LUMINARY.LIST_BY_TIME_ASC)
        end
        priceSorter = false
    end
end


local function _create_LumListView_row(LumSelf, i)
    local control = LumSelf.control
    local name = control:GetName() .. "_Line" .. i
    totalLines = i
    lthline = wm:CreateControl(name, control, CT_CONTROL)
    lthline:SetHeight(LumSelf.line_height)

    local message = LumSelf.sellLines[i]
    -- LUMINARY.logD("List view row" .. i)

    lthline.buyer = wm:CreateControl(name .. "_Buyer", lthline, CT_BUTTON)
    lthline.buyer:SetFont("ZoFontGame")
    lthline.buyer:SetDimensions(140, 25)
    lthline.buyer:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    --    lthline.buyer:SetColor(255, 255, 255, 1)--
    lthline.buyer:SetHandler("OnMouseDoubleClick", function() WhisperTarget(message.buyer) end)
    lthline.buyer:SetText(LUMINARY.color.colArcane .. message.buyer)
    lthline.buyer:SetAnchor(LEFT, lthline, nil, LEFT - 5, 20)

    -- local controlWidthz = control:GetWidth()
    lthline.frame = wm:CreateControl(name .. "_Frame", lthline, CT_TEXTURE)
    lthline.frame:SetDimensions(control:GetWidth(), 2)
    lthline.frame:SetAnchor(0, lthline, 0, LEFT, 15)

    lthline.frame:SetTexture("/esoui/art/guild/sectiondivider_left.dds")
    lthline.frame:SetTextureCoords(0, 1, 0, 1)
    lthline.frame:SetAlpha(0.7)

    --  name .. "_Guild"
    lthline.guild = wm:CreateControl(name .. "_Guild", lthline, CT_LABEL)
    lthline.guild:SetFont("ZoFontGame")
    lthline.guild:SetDimensions(125, 25)
    lthline.guild:SetColor(255, 255, 255, 1)
    lthline.guild:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    lthline.guild:SetText(LUMINARY.color.colWhite .. message.guildName)
    lthline.guild:SetAnchor(LEFT, lthline, nil, LEFT + 135, 20)



    lthline.itemIcon = wm:CreateControl(name .. "_ItemIcon", lthline, CT_TEXTURE)
    lthline.itemIcon:SetDimensions(30, 30)
    lthline.itemIcon:SetAnchor(LEFT, lthline, nil, LEFT + 290, 20)
    lthline.itemIcon:SetTextureCoords(0, 1, 0, 1)
    lthline.itemIcon:SetDrawLayer(0)
    lthline.itemIcon:SetDrawLayer(2)
    lthline.itemIcon:SetDrawTier(1)
    lthline.itemIcon:SetTexture(GetItemLinkInfo(message.itemName))
    lthline.itemIcon:SetHandler("OnMouseEnter", function() TouchMyTool(message.itemName) end)
    lthline.itemIcon:SetHandler("OnMouseExit", function() HideTouchMyTool(message.itemName) end)


    --  name .. "_Item"
    lthline.item = wm:CreateControl(name .. "_Item", lthline, CT_BUTTON)
    lthline.item:SetFont("ZoFontGame")
    lthline.item:SetDimensions(210, 25)
    lthline.item:SetText(LUMINARY.color.colArcane .. zo_strformat(SI_TOOLTIP_ITEM_NAME, message.itemName)) --  AWESOME thank you Saur
    lthline.item:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    lthline.item:SetHandler("OnMouseEnter", function() TouchMyTool(message.itemName) end)
    lthline.item:SetHandler("OnMouseExit", function() HideTouchMyTool(message.itemName) end)
    lthline.item:SetHandler("OnMouseDoubleClick", function() LinkInChat(message.itemName) end)
    --  lthline.item:SetHandler("OnMouseDoubleClick", function() LUMINARY.win.Main_Control.Searcher:SetText(message.cleanName) end)
    lthline.item:SetAnchor(LEFT, lthline, nil, LEFT + 325, 20)



    --  name .. "_Quantity"
    lthline.quantity = wm:CreateControl(name .. "_Quantity", lthline, CT_BUTTON)
    lthline.quantity:SetFont("ZoFontGame")
    lthline.quantity:SetDimensions(40, 25)
    lthline.quantity:SetText(LUMINARY.color.colWhite .. "  x" .. message.quantity)
    lthline.quantity:SetHandler("OnClicked", function() TouchMyTool(message.itemName) end)
    lthline.quantity:SetAnchor(0, lthline, 0, LEFT + 530, 20)


    lthline.timeSold = wm:CreateControl(name .. "_TimeSold", lthline, CT_LABEL)
    lthline.timeSold:SetFont("ZoFontGame")
    lthline.timeSold:SetDimensions(100, 25)
    lthline.timeSold:SetColor(255, 255, 255, 1)
    lthline.timeSold:SetAnchor(0, lthline, 0, LEFT + 575, 20)



    local TimeSince = GetTimeStamp()
    local tempTime = TimeSince - message.timestampz

    local secToMin = tonumber(string.format("%.4f", math.floor(tempTime / 60)))
    local minToHours = tonumber(string.format("%.4f", math.floor(tempTime / 60 / 60)))
    local hoursToDays = tonumber(string.format("%.4f", math.floor(tempTime / 60 / 60 / 24)))

    local LTHDisplayTime = tonumber(string.format("%.4f", math.floor(tempTime / 60 / 60)))

    if tempTime <= 59 then -- min
        lthline.timeSold:SetText(LUMINARY.color.colRed .. message.timestampz .. SI.get(SI.SECS))

    elseif tempTime <= 3599 then -- hour
        lthline.timeSold:SetText(LUMINARY.color.colRed .. secToMin .. SI.get(SI.MINS))

    elseif tempTime <= 86399 then -- day
        lthline.timeSold:SetText(LUMINARY.color.colRed .. minToHours .. SI.get(SI.HOURS))

    else
        lthline.timeSold:SetText(LUMINARY.color.colRed .. hoursToDays .. SI.get(SI.DAYS))
    end

    if not mLuminarySavedTHVarsNew.Pick_Gold then
        local somemath = message.soldAmount * GetTradingHouseCutPercentage() / 100
        local moreMath = message.soldAmount - somemath
        if moreMath % 2 ~= 0.5 then
            finalmath = math.floor(moreMath + 0.5)
        else finalmath = moreMath - 0.5
        end
    else
        finalmath = message.soldAmount
    end

    lthline.sellPrice = wm:CreateControl(name .. "_SellPrice", lthline, CT_LABEL)
    lthline.sellPrice:SetFont("ZoFontGame")
    lthline.sellPrice:SetColor(255, 255, 255, 1)
    lthline.sellPrice:SetText(LUMINARY.color.colLegendary .. finalmath .. " G")
    lthline.sellPrice:SetAnchor(0, lthline, 0, LEFT + 670, 20)




    -- low
    lthline.low = wm:CreateControl(name .. "_Low", lthline, CT_LABEL)
    lthline.low:SetFont("ZoFontGameMedium")
    lthline.low:SetDimensions(100, 25)
    lthline.low:SetColor(255, 255, 255, 1)
    lthline.low:SetText(LUMINARY.color.colTrash.. LUMINARY.lowest(message.itemName, message.soldAmount, message.quantity))
    lthline.low:SetAnchor(0, lthline, 0, LEFT + 740, 20)

-- high
    lthline.high = wm:CreateControl(name .. "_high", lthline, CT_LABEL)
    lthline.high:SetFont("ZoFontGameMedium")
    lthline.high:SetDimensions(100, 25)
    lthline.high:SetColor(255, 255, 255, 1)
    lthline.high:SetText(LUMINARY.color.colRed .. LUMINARY.highest(message.ItemName, message.soldAmount, message.quantity))
    lthline.high:SetAnchor(0, lthline, 0, LEFT + 790, 20)



    -- average
    lthline.mean = wm:CreateControl(name .. "_Average", lthline, CT_LABEL)
    lthline.mean:SetFont("ZoFontGameMedium")
    lthline.mean:SetDimensions(100, 25)
    lthline.mean:SetColor(255, 255, 255, 1)
    lthline.mean:SetText(LUMINARY.color.colMagic .. LUMINARY.mean(message.itemName))
    lthline.mean:SetAnchor(0, lthline, 0, LEFT + 840, 20)



    lthline.median = wm:CreateControl(name .. "_Median", lthline, CT_LABEL)
    lthline.median:SetFont("ZoFontGameMedium")
    lthline.median:SetDimensions(100, 25)
    lthline.median:SetColor(255, 255, 255, 1)
    lthline.median:SetText(LUMINARY.color.colLegendary .. LUMINARY.median(message.itemName))
    lthline.median:SetAnchor(0, lthline, 0, LEFT + 890, 20)


    lthline.std = wm:CreateControl(name .. "_STD", lthline, CT_LABEL)
    lthline.std:SetFont("ZoFontGameMedium")
    lthline.std:SetDimensions(100, 25)
    lthline.std:SetColor(255, 255, 255, 1)
    lthline.std:SetText(LUMINARY.color.colArtifact .. LUMINARY.standardDeviationStarter(message.itemName))
    lthline.std:SetAnchor(0, lthline, 0, LEFT + 940, 20)

--
--    lthline.mode = wm:CreateControl(name .. "_Mode", lthline, CT_LABEL)
--    lthline.mode:SetFont("ZoFontGame")
--    lthline.mode:SetDimensions(100, 25)
--    lthline.mode:SetColor(255, 255, 255, 1)
--    lthline.mode:SetText(LUMINARY.color.colLegendary .. LUMINARY.biggestStarter(message.cleanName))
--    lthline.mode:SetAnchor(0, lthline, 0, LEFT + 1030, 20)
--


    return lthline
end



local function _create_LumListView_lines_if_needed(LumSelf)
    local control = {}
    control = LumSelf.control
    -- Makes sure that the main control is filled up with line controls at all times.
    for i = 1, LumSelf.num_visible_lines do

        if control.sellLines[i] == nil then
            local line = _create_LumListView_row(LumSelf, i)
            control.sellLines[i] = line
            if i == 1 then
                line:SetAnchor(TOPLEFT, control, TOPLEFT, 0, LINES_OFFSET)
              else
                 line:SetAnchor(TOPLEFT, control.sellLines[i - 1], BOTTOMLEFT, 0, 0)
            end
        end
    end
end

local function _on_resize(LumSelf)

    local control = {}
    control = LumSelf.control

    -- Need to calculate num_visible_lines etc. for the rest of this function.
    _set_line_counts(LumSelf)

    _create_LumListView_lines_if_needed(LumSelf)

    -- Represent how many lines are visible atm.
    local viewable_lines_pct = LumSelf.num_visible_lines / #LumSelf.sellLines

    -- Can we see all the lines?
    if viewable_lines_pct >= 1.0 then
        control.slider:SetHidden(true)
    else
        -- If not, make sure the slider is showing.
        control.slider:SetHidden(false)
        LumSelf.control.slider:SetMinMax(0, LumSelf.num_hidden_lines)
        control.slider:SetHeight(control:GetHeight() - LINES_OFFSET)

        -- The more lines we can see, the bigger the slider should be.
        local tex = LumSelf.slider_texture
        -- TODO: I have no idea why I need to do "+ 8" to get it to fit here.. GOD I hate low level UI API's.
        control.slider:SetThumbTexture(tex, tex, tex, SLIDER_WIDTH + 8, control.slider:GetHeight() * viewable_lines_pct, 0, 0, 1, 1)
    end

    -- Update line widths in case we just resized LumSelf.control.
    local line_width = control:GetWidth()

    if not control.slider:IsControlHidden() then
        line_width = line_width - control.slider:GetWidth()
    end

    for _, line in pairs(control.sellLines) do
        line:SetWidth(line_width)
    end
end

local function _initialize_LumListView(LumSelf, width, height, msg)
    local lum_control = {}

    lum_control = LumSelf.control
    local name = lum_control:GetName()

    -- control
    lum_control:SetDimensions(width, height)
    lum_control:SetHidden(true)
    lum_control:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, LEFT + mLuminarySavedTHVarsNew.TH_x, mLuminarySavedTHVarsNew.TH_y)
    lum_control:SetMovable(true)
    --    control:SetResizeHandleSize(MOUSE_CURSOR_RESIZE_NS)
    lum_control:SetMouseEnabled(true)
    lum_control:SetClampedToScreen(true)

    -- control backdrop
    lum_control.bd = WINDOW_MANAGER:CreateControl(nil, lum_control, CT_TEXTURE)
    lum_control.bd:SetAnchor(CENTER, lum_control, CENTER, TOPLEFT, TOP + 50)
    lum_control.bd:SetDimensions(lum_control:GetWidth(), lum_control:GetHeight() + 200)
    lum_control.bd:SetTexture("/esoui/art/miscellaneous/centerscreen_left.dds")
    lum_control.bd:SetTextureCoords(0, 1, 0, 1)
    lum_control.bd:SetAlpha(1)

    -- control backdrop
    lum_control.bdTOP = WINDOW_MANAGER:CreateControl(nil, lum_control, CT_TEXTURE)
    lum_control.bdTOP:SetAnchor(TOPLEFT, lum_control, TOPLEFT, LEFT, -20)
    --  lum_control.bdTOP:SetAnchor(TOPCENTER,lum_control, TOPCENTER,  LEFT - 40)
    lum_control.bdTOP:SetDimensions(lum_control:GetWidth(), 20)
    lum_control.bdTOP:SetTexture("/esoui/art/miscellaneous/singlelinesection_left.dds")
    lum_control.bdTOP:SetTextureCoords(0, 1, 0, 1)
    lum_control.bdTOP:SetAlpha(1)

    --
    --  lum_control.bdBottom = WINDOW_MANAGER:CreateControl(nil, lum_control, CT_TEXTURE)
    --  lum_control.bdBottom:SetAnchor(BOTTOMLEFT,lum_control, BOTTOMLEFT, LEFT , 10)
    --  lum_control.bdBottom:SetDimensions(lum_control:GetWidth(), 20)
    --  lum_control.bdBottom:SetTexture("/esoui/art/miscellaneous/singlelinesection_left.dds")
    --  lum_control.bdBottom:SetTextureCoords(0, 1, 0, 1)
    --  lum_control.bdBottom:SetAlpha(1)


    lum_control.bdRIGHT = WINDOW_MANAGER:CreateControl(nil, lum_control, CT_TEXTURE)
    lum_control.bdRIGHT:SetAnchor(RIGHT, lum_control, RIGHT, RIGHT, 0)
    lum_control.bdRIGHT:SetDimensions(2, lum_control:GetHeight())
    lum_control.bdRIGHT:SetTexture("/esoui/art/miscellaneous/horizontaldivider.dds")
    lum_control.bdRIGHT:SetTextureCoords(0, 1, 0, 1)
    lum_control.bdRIGHT:SetAlpha(1)


    lum_control.bdLEFT = WINDOW_MANAGER:CreateControl(nil, lum_control, CT_TEXTURE)
    lum_control.bdLEFT:SetAnchor(LEFT, lum_control, LEFT, LEFT - 15, 0)
    lum_control.bdLEFT:SetDimensions(2, lum_control:GetHeight())
    lum_control.bdLEFT:SetTexture("/esoui/art/miscellaneous/horizontaldivider.dds")
    lum_control.bdLEFT:SetTextureCoords(0, 1, 0, 1)
    lum_control.bdLEFT:SetAlpha(1)





    -- th_Buyer
    if LumSelf.th_Buyer then
        lum_control.th_Buyer = wm:CreateControl(name .. "_Guild_BUYER", lum_control, CT_BUTTON)
        lum_control.th_Buyer:SetFont("ZoFontWinH4")
        lum_control.th_Buyer:SetDimensions(125, 20)
        -- lum_control.th_Buyer:SetColor(255, 255, 255, 1)
        lum_control.th_Buyer:SetText(LUMINARY.color.colArcane .. SI.get(SI.BUYER))
        lum_control.th_Buyer:SetHandler("OnMouseEnter", function() LUMINARY:tooltipTextEnter(lum_control.th_Buyer, "Double click buyer name to whisper.", true) end)

        lum_control.th_Buyer:SetHandler("OnMouseExit", function() LUMINARY:tooltipTextEnter(lum_control.th_Buyer) end)

        lum_control.th_Buyer:SetHeight(TITLE_HEIGHT)
        lum_control.th_Buyer:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT, 20)
        -- control.th_Buyer:SetAnchor(TOPRIGHT, control, TOPRIGHT, 0, 0)
    end




    -- th_Guild
    if LumSelf.th_Guild then
        lum_control.th_Guild = wm:CreateControl(name .. "_Guild_Guild", lum_control, CT_LABEL)
        lum_control.th_Guild:SetFont("ZoFontWinH4")
        lum_control.th_Guild:SetDimensions(155, 20)
        lum_control.th_Guild:SetColor(255, 255, 255, 1)
        lum_control.th_Guild:SetText(LUMINARY.color.colWhite .. SI.get(SI.GUILD))
        lum_control.th_Guild:SetHeight(TITLE_HEIGHT)
        lum_control.th_Guild:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 135, 20)
        -- control.th_Guild:SetAnchor(TOPRIGHT, control, TOPRIGHT, 100, 0)
    end


    -- th_Item
    if LumSelf.th_Item then
        lum_control.th_Item = wm:CreateControl(name .. "_Guild_Item", lum_control, CT_BUTTON)
        lum_control.th_Item:SetFont("ZoFontWinH4")
        lum_control.th_Item:SetDimensions(250, 20)
        --        lum_control.th_Item:SetColor(255, 255, 255, 1)
        lum_control.th_Item:SetText(LUMINARY.color.colMagic .. SI.get(SI.ITEMNAME))
        lum_control.th_Item:SetHandler("OnMouseEnter", function() LUMINARY:tooltipTextEnter(lum_control.th_Item, "Double click item to insert into chat.", true) end)
        lum_control.th_Item:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
        lum_control.th_Item:SetHandler("OnMouseExit", function() LUMINARY:tooltipTextEnter(lum_control.th_Item) end)
        lum_control.th_Item:SetHeight(TITLE_HEIGHT)
        lum_control.th_Item:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 355, 20)
        --  control.th_Item:SetAnchor(TOPRIGHT, control, TOPRIGHT, 410, 0)
    end




    if LumSelf.th_Time then
        lum_control.quantity = wm:CreateControl(nil, lum_control, CT_LABEL)
        lum_control.quantity:SetFont("ZoFontWinH4")
        lum_control.quantity:SetDimensions(20, 20)
        lum_control.quantity:SetColor(255, 255, 255, 1)
        lum_control.quantity:SetText("Q.")
        lum_control.quantity:SetHeight(TITLE_HEIGHT)
        lum_control.quantity:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 550, 20)
        --  control.th_Time:SetAnchor(TOPRIGHT, control, TOPRIGHT, 535, 0)
    end




    -- th_Guild
    if LumSelf.th_Time then
        lum_control.th_Time = wm:CreateControl(name .. "_Guild_TIME", lum_control, CT_BUTTON)
        lum_control.th_Time:SetFont("ZoFontWinH4")
        lum_control.th_Time:SetDimensions(100, 20)
        lum_control.th_Time:SetText(LUMINARY.color.colRed .. SI.get(SI.TIMESOLD))
        lum_control.th_Time:SetHeight(TITLE_HEIGHT)
        lum_control.th_Time:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 575, 20)
        lum_control.th_Time:SetHandler("OnMouseUp", function() sortByTime(LUMINARY.LIST_CONTROLLER) end)
        --  control.th_Time:SetAnchor(TOPRIGHT, control, TOPRIGHT, 535, 0)


        LUMINARY.sortByTime = wm:CreateControl(name .. "_Guild_TIME_TEX", lum_control, CT_TEXTURE)
        LUMINARY.sortByTime:SetDimensions(40, 40)
        LUMINARY.sortByTime:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 585, 35)
        LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        LUMINARY.sortByTime:SetTextureCoords(0, 1, 0, 1)
        LUMINARY.sortByTime:SetAlpha(1)
    end

    -- th_Guild
    if LumSelf.th_Price then
        lum_control.th_Price = wm:CreateControl(name .. "_Guild_PRICE", lum_control, CT_BUTTON)
        lum_control.th_Price:SetFont("ZoFontWinH4")
        lum_control.th_Price:SetDimensions(50, 20)
        lum_control.th_Price:SetText(LUMINARY.color.colLegendary .. SI.get(SI.PRICE))
        lum_control.th_Price:SetHeight(TITLE_HEIGHT)
        lum_control.th_Price:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 670, 20)
        lum_control.th_Price:SetHandler("OnMouseUp", function() sortByPrice(LUMINARY.LIST_CONTROLLER) end)
        -- control.th_Price:SetAnchor(TOPRIGHT, control, TOPRIGHT, 600, 0)

        LUMINARY.sortByPrice = wm:CreateControl(nil, lum_control, CT_TEXTURE)
        LUMINARY.sortByPrice:SetDimensions(40, 40)
        LUMINARY.sortByPrice:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 680, 35)
        LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        LUMINARY.sortByPrice:SetTextureCoords(0, 1, 0, 1)
        LUMINARY.sortByPrice:SetAlpha(1)
    end


    lum_control.MathOrSomething = wm:CreateControl(name .. "_MathStuff", lum_control, CT_LABEL)
    lum_control.MathOrSomething:SetFont("ZoFontGameMedium")
    lum_control.MathOrSomething:SetDimensions(300, 20)
    lum_control.MathOrSomething:SetText(LUMINARY.color.colLegendary .. SI.get(SI.PRICE))
    lum_control.MathOrSomething:SetHeight(TITLE_HEIGHT)
    lum_control.MathOrSomething:SetAnchor(LEFT, lum_control, TOPLEFT, TOPLEFT + 710, 60)
    lum_control.MathOrSomething:SetText(LUMINARY.color.colWhite .. "(EA)" .. LUMINARY.color.colTrash .. " Low   ".. LUMINARY.color.colRed .. "High   "
            ..LUMINARY.color.colMagic .. "Avg   " .. LUMINARY.color.colLegendary .. "Median   " .. LUMINARY.color.colArtifact .. "Std  ")


    -- slider
    local tex = LumSelf.slider_texture
    lum_control.slider = wm:CreateControl(name .. "_Slider", lum_control, CT_SLIDER)
    lum_control.slider:SetWidth(SLIDER_WIDTH)
    lum_control.slider:SetMouseEnabled(true)
    lum_control.slider:SetValue(0)
    lum_control.slider:SetValueStep(1)
    lum_control.slider:SetAnchor(TOPRIGHT, lum_control, TOPRIGHT, 60, 0)

    -- lines
    lum_control.sellLines = {}
    _on_resize(LumSelf) -- sets important datastructures
    _create_LumListView_lines_if_needed(LumSelf)

    local me = LumSelf

    -- event: mwheel
    lum_control:SetHandler("OnMouseWheel", function(LumSelf, delta)
        me.offset = clamp(me.offset - delta, 0, me.num_hidden_lines)
        lum_control.slider:SetValue(me.offset)
    end)

    -- event: slider
    lum_control.slider:SetHandler("OnValueChanged", function(LumSelf, val, eventReason)
        me.offset = clamp(val, 0, me.num_hidden_lines)
        me:update()
    end)

    -- event: resize
    lum_control:SetHandler("OnResizeStart", function(LumSelf)
        me.currently_resizing = true
    end)

    lum_control:SetHandler("OnResizeStop", function(LumSelf)
        me.currently_resizing = false
        _on_resize(me)
        me:update()
    end)

    -- event: control update
    lum_control:SetHandler("OnUpdate", function(LumSelf, elapsed)
        me:update()
    end)

    -- event: control update
    lum_control:SetHandler("OnMouseUp", function(self)
        mLuminarySavedTHVarsNew.TH_x = math.floor(LUMINARY.win.Main_Control:GetLeft())
        mLuminarySavedTHVarsNew.TH_y = math.floor(LUMINARY.win.Main_Control:GetTop())
        --  lum_control.bdBottom:SetDimensions( lum_control:GetWidth(), 20)
        lum_control.bdTOP:SetDimensions(lum_control:GetWidth(), 20)
        lum_control.bdRIGHT:SetDimensions(7, lum_control:GetHeight())
        lum_control.bd:SetDimensions(lum_control:GetWidth(), lum_control:GetHeight() + 150)
        lum_control.bdLEFT:SetDimensions(7, lum_control:GetHeight())
    end)
end

-- LumListView, public API

local LumListView = {}

function LumListView.new(control, settings, msg)
    settings = settings or {}

    -- Not storing these in LumSelf; use LumSelf.control:GetWidth() and LumSelf.control:GetHeight()
    local width = settings.width or 400
    local height = settings.height or 500

    LumSelf = {
        line_height = settings.line_height or 35,
        slider_texture = settings.slider_texture or "/esoui/art/miscellaneous/scrollbox_elevator.dds",
        th_Buyer = "Buyer:",
        th_Guild = "Guild: ",
        th_Item = "Item: ",
        th_Price = "Price: ",
        th_Time = "Time: ",
        control = control,
        name = control:GetName(),
        offset = 0,
        sellLines = {},
        currently_resizing = false,
    }

    -- TODO: Translate LumSelf:SetHidden() etc. to LumSelf.control:SetHidden()
    setmetatable(LumSelf, { __index = LumListView })

    _initialize_LumListView(LumSelf, width, height)

    return LumSelf
end







function LUMINARY.sorter(type, sort)

    LUMINARY.getAllSales(false)

    if type == LUMINARY.LIST_BY_ALL then
        zo_callLater(function()     setupRecentSales(LUMINARY.LIST_BY_ALL, sort) end, 12500)

    elseif type == LUMINARY.LIST_BY_SELF then
        zo_callLater(function()    setupRecentSales(LUMINARY.LIST_BY_SELF, sort) end, 12500)

    elseif type == LUMINARY.LIST_BY_SEARCH then
        zo_callLater(function()    LUMINARY.SearchGuildHistory(LUMINARY.win.Main_Control.Searcher:GetText(), sort) end, 12500)


    else
        zo_callLater(function()   setupRecentSales(LUMINARY.LIST_BY_ALL, sort) end, 12500)

    end
    zo_callLater(function()  LumSelf:update() end, 13500)

end



function refreshTotalSales()
    LUMINARY.sorter(LUMINARY.LIST_CONTROLLER, LUMINARY.LIST_BY_TIME_ASC)
    d(SI.get(SI.REFRESHINGSALES))

    zo_callLater(function()  d("Refresh Complete") end, 13510)

end









-------------------------- UPDATE CALLED HERE -----------------------------------------------------------------------------------------------------
function LumListView:update()
    local throttle_time = LumSelf.currently_resizing and 0.01
    if LumUnicorn.throttle(LumSelf, 0.01) then
        return
    end

    if LumSelf.currently_resizing then
        _on_resize(LumSelf)
    end

    -- Goes through each line control and either shows a message or hides it.
    for i, line in pairs(LumSelf.control.sellLines) do
        local message = LumSelf.sellLines[i + LumSelf.offset] -- LumSelf.offset = how much we've scrolled down
        -- Only show messages that will be displayed within the control.
        if message ~= nil and i <= LumSelf.num_visible_lines then
            local TimeSince = GetTimeStamp()

            local tempTime = TimeSince - message.timestampz
            --   LUMINARY.logD("Scroll" .. i)
            local secToMin = tonumber(string.format("%.4f", math.floor(tempTime / 60)))
            local minToHours = tonumber(string.format("%.4f", math.floor(tempTime / 60 / 60)))
            local hoursToDays = tonumber(string.format("%.4f", math.floor(tempTime / 60 / 60 / 24)))

            if tempTime <= 59 then
                line.timeSold:SetText(LUMINARY.color.colRed .. message.secsSinceEvent .. SI.get(SI.SECS))

            elseif tempTime <= 3599 then
                line.timeSold:SetText(LUMINARY.color.colRed .. secToMin .. SI.get(SI.MINS))

            elseif tempTime <= 86399 then
                line.timeSold:SetText(LUMINARY.color.colRed .. minToHours .. SI.get(SI.HOURS))
            else
                line.timeSold:SetText(LUMINARY.color.colRed .. hoursToDays .. SI.get(SI.DAYS))
            end
            LUMINARY.win.Main_Control.Searcher:SetSimpleAnchorParent(15, 25)
            line.buyer:SetText(LUMINARY.color.colArcane .. message.buyer)
            line.buyer:SetHandler("OnMouseDoubleClick", function() WhisperTarget(message.buyer) end)
            line.guild:SetText(LUMINARY.color.colWhite .. message.guildName)
            line.quantity:SetText(LUMINARY.color.colWhite .. "  x" .. message.quantity)


            -------- stupid shit math
            line.mean:SetText(LUMINARY.color.colMagic .. LUMINARY.mean(message.itemName))
            line.high:SetText(LUMINARY.color.colRed .. LUMINARY.highest(message.itemName, message.soldAmount, message.quantity))
            line.low:SetText(LUMINARY.color.colTrash.. LUMINARY.lowest(message.itemName, message.soldAmount, message.quantity))
          --  line.mode:SetText(LUMINARY.color.colLegendary .. LUMINARY.biggestStarter(message.cleanName))
            line.median:SetText(LUMINARY.color.colLegendary .. LUMINARY.median(message.itemName))
            line.std:SetText(LUMINARY.color.colArtifact .. LUMINARY.standardDeviationStarter(message.itemName))



            line.item:SetText(LUMINARY.color.colArcane .. zo_strformat(SI_TOOLTIP_ITEM_NAME, message.itemName)) --  AWESOME thank you Saur
            line.item:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
            line.item:SetHandler("OnMouseEnter", function() TouchMyTool(message.itemName) end)
            line.item:SetHandler("OnMouseExit", function() HideTouchMyTool(message.itemName) end)
            line.item:SetHandler("OnMouseDoubleClick", function() LinkInChat(message.itemName) end)

            line.itemIcon:SetTexture(GetItemLinkInfo(message.itemName))
            line.itemIcon:SetHandler("OnMouseEnter", function() TouchMyTool(message.itemName) end)
            line.itemIcon:SetHandler("OnMouseExit", function() HideTouchMyTool(message.itemName) end)

            if not mLuminarySavedTHVarsNew.Pick_Gold then
                local somemath = message.soldAmount * GetTradingHouseCutPercentage() / 100
                local moreMath = message.soldAmount - somemath
                if moreMath % 2 ~= 0.5 then
                    finalmath = math.floor(moreMath + 0.5)
                else finalmath = moreMath - 0.5
                end
            else
                finalmath = message.soldAmount
            end
            line.sellPrice:SetText(LUMINARY.color.colLegendary .. finalmath .. " G")

            line:SetHidden(false)
        else
            line:SetHidden(true)
        end
    end
end

function LumListView:clear()
    LumListView = {}
    LumSelf.sellLines = {}
    LumSelf:update()
end

function LumListView:add_message(message, sort)
    LumSelf.sellLines = {}
    if message == nil then return end

    for k, v in pairs(message) do LumSelf.sellLines[k] = v
    if LumSelf.sellLines.timestampz ~= message.timestampz then
        table.insert(LumSelf.sellLines, message)
    end
    end


    if sort == LUMINARY.LIST_BY_PRICE_DESC then
        table.sort(LumSelf.sellLines, function(a, b) return a.soldAmount < b.soldAmount end)
    elseif sort == LUMINARY.LIST_BY_PRICE_ASC then
        table.sort(LumSelf.sellLines, function(a, b) return a.soldAmount > b.soldAmount end)

    elseif sort == LUMINARY.LIST_BY_TIME_DESC then
        table.sort(LumSelf.sellLines, function(a, b) return a.timestampz < b.timestampz end)
    elseif sort == LUMINARY.LIST_BY_TIME_ASC then
        table.sort(LumSelf.sellLines, function(a, b) return a.timestampz > b.timestampz end)
    else
        table.sort(LumSelf.sellLines, function(a, b) return a.timestampz > b.timestampz end)
    end

    LumListView = {}
    _on_resize(LumSelf) -- maybe the function needs a better name :)
    LumSelf:update()
end

LumUnicorn.LumListView = LumListView
