--- - Table to hold statistical functions
local stats = {}
--
--- - Get the mean /average value of a table
function LUMINARY.mean(name)
    local sum = 0
    local count = 0

    for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do
        if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName then
            sum = sum + mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount
            count = count + mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity
        end
    end
    return string.format("%.f", sum / count)
end





--- - Get the high of a table.  Returns a table of values.
function LUMINARY.highest(name, amount, quantity)
    local biggestCount = amount / quantity

    for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do
        if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName then
            if mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity
                    >= biggestCount then
                biggestCount = mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity
                --    else
                --    biggestCount = amount / quantity
            end
        end
    end

    return string.format("%.f", biggestCount)
end




--- - Get the low est of a table.  Returns a table of values.
function LUMINARY.lowest(name, amount, quantity)
    local lowestCount = amount / quantity

    for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do
        if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName then
            if mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity
                    <= lowestCount then
                lowestCount = mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity
                --    else
                --    biggestCount = amount / quantity
            end
        end
    end

    return string.format("%.f", lowestCount)
end





function LUMINARY.medianStarter(t)
    local temp = {}

    -- deep copy table so that when we sort it, the original is unchanged
    -- also weed out any non numbers
    for k, v in pairs(t) do
        if type(v) == 'number' then
            table.insert(temp, v)
        end
    end

    table.sort(temp)

    -- If we have an even number of table elements or odd.
    if temp ~= nil then
        local value = math.fmod(#temp, 2)

        if value == 0 then
            -- going mto need to fix this math. its incorrect.
            -- return mean value of middle two elements
            return 0
        else
            -- return middle element
            return temp[math.ceil(#temp / 2)]
        end
    else
        return 0
    end
end



--
--- - Get the median of a table.
function LUMINARY.median(name)
    local temp = {}
    for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do
        if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName then
            table.insert(temp, mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity)
        end
    end
    local result = LUMINARY.medianStarter(temp)
    if result == 0 then
        return "-"
    else
        return string.format("%.f", result)
    end
end





----------------------------------------------------------------------------------------- Standard Deviation



-- Get the mean value of a table
function stats.mean(t)
    local sum = 0
    local count = 0

    for k, v in pairs(t) do
        if type(v) == 'number' then
            sum = sum + v
            count = count + 1
        end
    end

    return (sum / count)
end


function LUMINARY.standardDeviation(t)
    local m
    local vm
    local sum = 0
    local count = 0
    local result

    m = stats.mean(t)

    for k, v in pairs(t) do
        if type(v) == 'number' then
            vm = v - m
            sum = sum + (vm * vm)
            count = count + 1
        end
    end

    result = math.sqrt(sum / (count - 1))

    return string.format("%.f", result)
end

function LUMINARY.standardDeviationStarter(name)
    local temp = {}


    for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do

        if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName and index == index then
            table.insert(temp, mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity)
        end
    end
    local result = string.format("%.f", LUMINARY.standardDeviation(temp))
    if (result == string.format(-1)) then

        return "-"
    else

        return result
    end
end

-----------------------------------------------------------------------------------------------------------
---------------------------------------------------- biggest -----------------------------------------
---------------------------------------------------------------------------------------------------------
-- function stats.mode( t )
-- local counts={}
--
-- for k, v in pairs( t ) do
-- if counts[v] == nil then
-- counts[v] = 1
-- else
-- counts[v] = counts[v] + 1
-- end
-- end
--
-- local biggestCount = 0
--
-- for k, v  in pairs( counts ) do
-- if v > biggestCount then
-- biggestCount = v
-- end
-- end
--
-- local temp={}
--
-- for k,v in pairs( counts ) do
-- if v == biggestCount then
-- table.insert( temp, k )
-- end
-- end
--
-- return temp.soldAmount
-- end
--
-- function LUMINARY:biggestStarter(name)
--
-- local temp = {}
-- for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do
-- if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName then
-- table.insert(temp, mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount  / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity)
-- end
--
-- end
-- local result = stats.mode( temp )
-- return string.format("%.f", result)
-- end
--


---------------------------------------------------------------------------------------------
----------------------------- MIN MAX ----------------------------------------------------
-----------------------------------------------------------------------------------------
-- Get the max and min for a table
-- function stats.maxmin( t )
-- local max = -math.huge
-- local min = math.huge
--
-- for k,v in pairs( t ) do
-- if type(v) == 'number' then
-- max = math.max( max, v )
-- min = math.min( min, v )
-- end
-- end
--
-- return max, min
-- end
--
-- function LUMINARY:minmaxStarter(name)
--
-- local temp = {}
-- for i = 1, #mLuminarySavedTHVarsNew.ALL_GUILD_SALES do
-- if name == mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].itemName then
-- table.insert(temp, mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].soldAmount  / mLuminarySavedTHVarsNew.ALL_GUILD_SALES[i].quantity)
-- end
--
-- end
-- local min, max = LUMINARY.maxmin( temp )
-- return string.format("%.f", min), string.format("%.f", max)
-- end




-- high -- number that occurs most often
-- media


--
--
--- - Get the standard deviation of a table
-- function stats.standardDeviation(t)
-- local m
-- local vm
-- local sum = 0
-- local count = 0
-- local result
--
-- m = stats.mean(t)
--
-- for k, v in pairs(t) do
-- if type(v) == 'number' then
-- vm = v - m
-- sum = sum + (vm * vm)
-- count = count + 1
-- end
-- end
--
-- result = math.sqrt(sum / (count - 1))
--
-- return result
-- end
--
---- Get the max and min for a table
-- function stats.maxmin(t)
-- local max = -math.huge
-- local min = math.huge
--
-- for k, v in pairs(t) do
-- if type(v) == 'number' then
-- max = math.max(max, v)
-- min = math.min(min, v)
-- end
-- end
--
-- return max, min
-- end
